﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace AdditionalRowInfo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("id", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Number", typeof(string));
            dt.Columns.Add("Name", typeof(string));
            dt.Columns.Add("Task Name", typeof(string));
            dt.Columns.Add("Resource", typeof(string));

            dt.Columns.Add("Dev_Reason", typeof(string));
            dt.Columns.Add("Dev_Note", typeof(string));
            dt.Columns.Add("Task_Note", typeof(string));
            dt.Columns.Add("Shift future Dates", typeof(bool));

            for (int i = 0; i < 100; i++)
            {
                igCmbDevReas.ValueList.ValueListItems.Add(string.Format("Dev. Reason {0}", i));
            }

            for (int i = 0; i < 10; i++)
            {
                dt.Rows.Add(null, string.Format("Number {0}", i), string.Format("Name {0}", i), string.Format("Task {0} Name", i),
                    string.Format("Resource {0}", i), string.Format("Dev. Reason {0}", i), string.Format("Dev. Note {0}", i),
                    string.Format("Task Note {0}", i), i % 3 == 0);   
            }

            ultraPanel1.Width = ultraGrid1.Width;


            Binding b = igCmbDevReas.DataBindings.Add("Value", dt, "Dev_Reason");
            b.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
            b.ControlUpdateMode = ControlUpdateMode.OnPropertyChanged;

            b = igTxtDevNote.DataBindings.Add("Text", dt, "Dev_Note");
            b.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
            b.ControlUpdateMode = ControlUpdateMode.OnPropertyChanged;

            b= igTxtTaskNote.DataBindings.Add("Text", dt, "Task_Note");
            b.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
            b.ControlUpdateMode = ControlUpdateMode.OnPropertyChanged;

            b=chBoxShiftDate.DataBindings.Add("Checked", dt, "Shift future Dates");
            b.DataSourceUpdateMode = DataSourceUpdateMode.OnPropertyChanged;
            b.ControlUpdateMode = ControlUpdateMode.OnPropertyChanged;


            ultraPanel1.DataBindings.Add("Width", ultraGrid1, "Width");
            ultraGrid1.SyncWithCurrencyManager = true;

            
            ultraPanel1.BringToFront();

            ultraGrid1.DataSource = dt;
        }

        private void ShowAdditionalPanel(bool show)
        {
            ultraPanel1.Visible = show;
        }


        private void ultraGrid1_AfterRowActivate(object sender, EventArgs e)
        {
            UltraGrid grid = sender as UltraGrid;
            RowUIElement rowUIElement = grid.ActiveRow.GetUIElement() as RowUIElement;
            Point p = rowUIElement.Rect.Location;

            if ((p.Y + rowUIElement.Rect.Height + ultraPanel1.Height) > ultraPanel1.Parent.Height)
            {
               p.Offset(0, -ultraPanel1.Height);
            }
            else
            {
                p.Offset(0, rowUIElement.Rect.Height);
            }
           
            p.X = 0;
            ultraPanel1.Location = p;


        }

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            foreach (UltraGridColumn col in e.Layout.Bands[0].Columns)
                col.Hidden = col.Index > 5;
        }

        private void ultraGrid1_AfterEnterEditMode(object sender, EventArgs e)
        {
            ShowAdditionalPanel(true);
        }

        private void ultraGrid1_AfterExitEditMode(object sender, EventArgs e)
        {
            ShowAdditionalPanel(false);
        }
    }
}
